#!/bin/ksh93
#
###############################################################################
# SHELL SCRIPT SOURCE FILE
#
# PROGRAM NAME :       .sh
# DESCRIPTION :        This script has been developed to monitor and report on
#                      java process uptime to help identify processess that 
#	                     are not regularly bounced
#
###############################################################################
#
###############################################################################
# CHANGE DESCRIPTION :    Draft version with FIX option
#
#############################################################################################

#Global Variables

maxDays=0
pidList=""

write_metric()
{
        print "<metric type=\"${1}\"  name=\"CPUProcs2|${2}:${3}\" value=\"${4}\"/>"
}

#Function to get java process uptime stats
JavaUptime()
{
	ps -efo '%t %c %p %a' | grep java | grep -v itlm | grep -v Symantec | while read elapsed command pid cmdargs rest
	do
		len=${#elapsed}		
		if [[ $len -gt "9" ]] ; then
			echo $elapsed | awk '{ print substr( $0, 0, length($0) - 9 ) }' | read days
		else
			days=0
		fi
		
		if [[ "$days" -gt "$maxDays" ]] ; then
			maxDays=$days
		fi
		
		if [[ $days -gt "7" ]]; then	
			pidList=$pidList"--"$pid
		fi		
	done
  write_metric IntCounter JavaUpTime MaxDays $maxDays	 
 	write_metric StringEvent JavaUpTime PidsGTOneWeek $pidList 
	
}


##########################################################################
# Main script
##########################################################################
. /usr/local/mware/bin/ksh.function_library

dontRunMeTwice
trap exitTrap 1 2 3 6 9 14 15

JavaUptime

dontRunMeTwice rm
